#ifndef EFL_GENERATED_ECORE_AUDIO_OUT_HH
#define EFL_GENERATED_ECORE_AUDIO_OUT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio_out.eo.h"
}

#include "ecore_audio.eo.hh"
#include <eo_base.hh>

struct ecore_audio_out
      : ecore_audio
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_out(Eo* eo)
      : ecore_audio(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio_out(std::nullptr_t)
      : ecore_audio(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   ecore_audio_out(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_out(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_out(ecore_audio_out const& other)
      : ecore_audio(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_out() {}

   /// @brief Set the virtual IO functions
   ///
   /// @since 1.8
   ///
   /// @param vio 
   /// @param data 
   /// @param free_func 
   ///
   void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
   }

   /// @brief Attach an input to an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   bool input_attach(efl::eo::base input_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_attach(efl::eolian::to_c(input_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Detach an input from an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   bool input_detach(efl::eo::base input_) const
   {
      Eina_Bool _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_detach(efl::eolian::to_c(input_)));
      return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
   }

   /// @brief Returns the list of all attached inputs
   ///
   /// @since 1.8
   ///
   efl::eina::range_list< efl::eo::base > inputs_get() const
   {
      Eina_List * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_inputs_get());
      return efl::eolian::to_cxx<efl::eina::range_list< efl::eo::base >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
   }

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OUT_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(ECORE_AUDIO_OUT_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _ecore_audio_out_vio_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
{
   static_cast<T*>(self->this_)->vio_set(vio_, data_, free_func_);
}

template <typename T>
bool _ecore_audio_out_input_attach_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eo * input_)
{
   return static_cast<T*>(self->this_)->input_attach(efl::eolian::to_cxx<efl::eo::base>(input_, std::tuple<std::false_type>()));
}

template <typename T>
bool _ecore_audio_out_input_detach_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, Eo * input_)
{
   return static_cast<T*>(self->this_)->input_detach(efl::eolian::to_cxx<efl::eo::base>(input_, std::tuple<std::false_type>()));
}

template <typename T>
efl::eina::range_list< efl::eo::base > _ecore_audio_out_inputs_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self)
{
   return static_cast<T*>(self->this_)->inputs_get();
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_out >
{
   template <typename T>
   struct type
   {
      virtual void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
      }

      virtual bool input_attach(efl::eo::base input_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_out_input_attach(efl::eolian::to_c(input_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool input_detach(efl::eo::base input_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_out_input_detach(efl::eolian::to_c(input_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual efl::eina::range_list< efl::eo::base > inputs_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_out_inputs_get());
            return efl::eolian::to_cxx<efl::eina::range_list< efl::eo::base >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio_out >
{
   static const int value = 4;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_out>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_ecore_audio_out_vio_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_vio_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_ecore_audio_out_input_attach_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_input_attach);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_ecore_audio_out_input_detach_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_input_detach);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_ecore_audio_out_inputs_get_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_inputs_get);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_out >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_out, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::ecore_audio_out >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_out, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::ecore_audio_out>
{
   template <typename U>
   struct type
   {
      operator ::ecore_audio_out() const
      {
         return ::ecore_audio_out(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void vio_set(Ecore_Audio_Vio * vio_, void * data_, eo_key_data_free_func free_func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_vio_set(vio_, data_, free_func_));
      }

      bool input_attach(efl::eo::base input_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_attach(efl::eolian::to_c(input_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      bool input_detach(efl::eo::base input_)
      {
         Eina_Bool _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_detach(efl::eolian::to_c(input_)));
            return efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      efl::eina::range_list< efl::eo::base > inputs_get()
      {
         Eina_List * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_inputs_get());
            return efl::eolian::to_cxx<efl::eina::range_list< efl::eo::base >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_out>)
{
   return (ECORE_AUDIO_OUT_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_OUT_HH

